//+------------------------------------------------------------------+
//|                                                    MA+MACD.mq4   |
//|                                               Copyright  2009   | 
//+------------------------------------------------------------------+
#property copyright " Copyright  2009  "
#property link      "gintariukstis@takas.lt"




//----------------------- EA PARAMETER
extern string           Expert_Pavadinimas      = "---------- Andriaus MA+MACD";
extern double           Lotas                   =0.01;
extern double 		     	MaximumRisk             = 0.12;  //11
extern double 		   	DecreaseFactor          = 3;

extern int              slip                    =5;
       int              MagicNumeris            = 1234;
extern double           StopLoss                = 200,
                        TakeProfit              = 200;
extern string           TrailingStop            = "---------- Trailing Stop nustatymai";                        
extern int              iTrldistance            = 200, //Atstumas nuo kurio sudirba
                        iTrlstep                = 400; //Zingsnis 
extern string           Indicator_Nustatymai    = "---------- Indikatoriu nustatymai";
extern string           MA_Nustatymai           = "---------- MA nustatymai";

extern int              MA_gr_Periodas          = 2;
extern string           MA_gr_TipoAprasas       = "----  0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int              MA_gr_Tipas             = 0;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern string           MA_gr_KainosAprasas     = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MA_gr_Kaina             = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        MA_gr_Poslinkis         = 0,
                        
                        MA_let_Periodas         = 19;
extern string           MA_let_TipoAprasas      = "----  0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int              MA_let_Tipas            = 0;    //0:SMA 1:EMA 2:SMMA 3:LWMA
extern string           MA_let_KainosAprasas    = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MA_let_Kaina            = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted
                        MA_let_Poslinkis        = 0;
                        
extern string           MACD_Nustatymai         = "---------- MACD nustatymai";
                        
extern int              Greitas_EMA             = 5;
extern int              Letas_EMA               = 8;
extern int              MACD_SMA                = 1;
extern string           MACD_KainosAprasas    = "---- 0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted";
extern int              MACD_Kaina            = 0,    //0:Close 1:Open 2:High 3:Low 4:Median 5:Typical 6:Weighted   
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
 
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lotas;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/500,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<1) lot=1;
   if(lot>1000) lot=1000;
   return(lot);
  }  
 //-------------------------------------------------------------------+
 //TrailingStop
 //-------------------------------------------------------------------+
 //http://codebase.mql4.com/ru/1101#comments
 //-------------------------------------------------------------------+
 void TrailingStairs(int ticket,int trldistance,int trlstep)
   { 
   
   double nextstair; // ????????? ???????? ?????, ??? ??????? ????? ?????? ????????

   // ????????? ?????????? ????????
   if ((trldistance<MarketInfo(Symbol(),MODE_STOPLEVEL)) || (trlstep<1) || (trldistance<trlstep) || (ticket==0) || (!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)))
      {
      Print("???????? ???????? TrailingStairs() ?????????? ??-?? ?????????????? ???????? ?????????? ?? ??????????.");
      return(0);
      } 
   
   // ???? ??????? ??????? (OP_BUY)
   if (OrderType()==OP_BUY)
      {
      // ???????????, ??? ????? ???????? ????? ??????? ??????????????? ????????
      // ???? ???????? ???? ???????? ??? ????? 0 (?? ?????????), ?? ????????? ??????? = ???? ???????? + trldistance + ?????
      if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice()))
      nextstair = OrderOpenPrice() + trldistance*Point;
         
      // ????? ????????? ??????? = ??????? ???????? + trldistance + trlstep + ?????
      else
      nextstair = OrderStopLoss() + trldistance*Point;

      // ???? ??????? ???? (Bid) >= nextstair ? ????? ???????? ????? ????? ????????, ???????????? ?????????
      if (Bid>=nextstair)
         {
         if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice()) && (OrderOpenPrice() + trlstep*Point<Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)) 
            {
            if (!OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() + trlstep*Point,OrderTakeProfit(),OrderExpiration()))
            Print("?? ??????? ?????????????? ???????? ?????? ?",OrderTicket(),". ??????: ",GetLastError());
            }
         }
      else
         {
         if (!OrderModify(ticket,OrderOpenPrice(),OrderStopLoss() + trlstep*Point,OrderTakeProfit(),OrderExpiration()))
         Print("?? ??????? ?????????????? ???????? ?????? ?",OrderTicket(),". ??????: ",GetLastError());
         }
      }
      
   // ???? ???????? ??????? (OP_SELL)
   if (OrderType()==OP_SELL)
      { 
      // ???????????, ??? ????? ???????? ????? ??????? ??????????????? ????????
      // ???? ???????? ???? ???????? ??? ????? 0 (?? ?????????), ?? ????????? ??????? = ???? ???????? + trldistance + ?????
      if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice()))
      nextstair = OrderOpenPrice() - (trldistance + MarketInfo(Symbol(),MODE_SPREAD))*Point;
      
      // ????? ????????? ??????? = ??????? ???????? + trldistance + trlstep + ?????
      else
      nextstair = OrderStopLoss() - (trldistance + MarketInfo(Symbol(),MODE_SPREAD))*Point;
       
      // ???? ??????? ???? (???) >= nextstair ? ????? ???????? ????? ????? ????????, ???????????? ?????????
      if (Ask<=nextstair)
         {
         if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice()) && (OrderOpenPrice() - (trlstep + MarketInfo(Symbol(),MODE_SPREAD))*Point>Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            {
            if (!OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() - (trlstep + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration()))
            Print("?? ??????? ?????????????? ???????? ?????? ?",OrderTicket(),". ??????: ",GetLastError());
            }
         }
      else
         {
         if (!OrderModify(ticket,OrderOpenPrice(),OrderStopLoss()- (trlstep + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration()))
         Print("?? ??????? ?????????????? ???????? ?????? ?",OrderTicket(),". ??????: ",GetLastError());
         }
      }      
   }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
	{
		int ma_b,ma_s,macd_b,macd_s;
		int ticket1,ticket2; 
		double ma_let_0 ,ma_gr_0,ma_let_1,ma_gr_1,ma_let_2,ma_gr_2;
		double macd_1,macd_2;
		int kk,gle;  
		int cnt,  total;
		//**********************************************************************************
		//Indikatoriu kintamieji VAriable
		//**********************************************************************************
	
		ma_let_0 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,0);
		ma_gr_0  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 0);         
		ma_let_1 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,1);
		ma_gr_1  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 1);
		ma_let_2 =iMA(NULL,0,MA_let_Periodas, MA_let_Poslinkis,MA_let_Tipas,MA_let_Kaina,2);
		ma_gr_2  =iMA(NULL,0,MA_gr_Periodas,  MA_gr_Poslinkis, MA_gr_Tipas, MA_gr_Kaina, 2);
	
		macd_1  =iMACD(NULL,0,Greitas_EMA,Letas_EMA ,MACD_SMA,MACD_Kaina,MODE_MAIN,1);
		macd_2  =iMACD(NULL,0,Greitas_EMA,Letas_EMA ,MACD_SMA,MACD_Kaina,MODE_MAIN,2);  
		bool est_s, est_b;  
		total=OrdersTotal();
		est_s=true;
		est_b=true;
		for(cnt=0;cnt<total;cnt++)
		{
			OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
			if((OrderType()==OP_SELL) && (OrderSymbol()==Symbol()))
			est_s=false;
			if((OrderType()==OP_BUY) && (OrderSymbol()==Symbol())) 
			est_b=false;
		} 
		if(total<2) 
		{
			// no opened orders identified
			if(AccountFreeMargin()<(1000*Lotas))
			{
				Print("We have no money. Free Margin = ", AccountFreeMargin());
				return(0);  
			}
			//**********************************************************************************
			// check for long position (BUY) possibility	
			//**********************************************************************************	
			if(ma_let_2>ma_gr_2 && ma_gr_1>ma_let_1 && macd_2<=0 && macd_1>0 && est_b==false)
			{
				kk=0;
				while(ticket1==-1 && kk<3)
				{
					ticket1=OrderSend(Symbol(),OP_BUY,Lotas,Ask,3,Ask-StopLoss*Point,TakeProfit*Point,"MA+MACD",MagicNumeris,slip,Green);//Ask-TakeProfit*Point        
					if (ticket1==-1)
					{
						gle=GetLastError();
						kk++;               
						Print("Error code ?",gle," SELL counter ",kk);
						Sleep(6000);
						RefreshRates();   
					}
				}
				kk=0;  
				while(ticket2==-1 && kk<3)
				{
					ticket2=OrderSend(Symbol(),OP_BUY,Lotas,Ask,3,Ask-StopLoss*Point,TakeProfit*Point,"MA+MACD",MagicNumeris+1,slip,Green);//Ask-TakeProfit*Point
					if (ticket2==-1)
					{
						gle=GetLastError();
						kk++;               
						Print("Error code ?",gle," SELL counter ",kk);
						Sleep(6000);
						RefreshRates();   
					}
				}  
			}	
			//*****************************************************************						
			// check for short position (SELL) possibility		
			//*****************************************************************	
			if(ma_let_2<ma_gr_2 && ma_gr_1<ma_let_1 && macd_2>=0 && macd_1<0) 
			{
				kk=0;
				while(ticket1==-1 && kk<3)
				{
					ticket1=OrderSend(Symbol(),OP_SELL,Lotas,Bid,3,Bid+StopLoss*Point,TakeProfit*Point,"MA+MACD",MagicNumeris,slip,Red);
					if (ticket1==-1)
					{
						gle=GetLastError();
						kk++;               
						Print("Error code ?",gle," BUY counter ",kk);
						Sleep(6000);
						RefreshRates();   
					}
				}
				kk=0;  
				while(ticket2==-1 && kk<3)
				{
					ticket2=OrderSend(Symbol(),OP_SELL,Lotas,Bid,3,Bid+StopLoss*Point,TakeProfit*Point,"MA+MACD",MagicNumeris+1,slip,Red);
					if (ticket2==-1)
					{
						gle=GetLastError();
						kk++;               
						Print("Error code ?",gle," BUY counter ",kk);
						Sleep(6000);
						RefreshRates();   
					}
				}   
			}
		}
		//***********************************************************
		//UZDARYMA	  EXIT
		//***********************************************************
		TrailingStairs(ticket2,iTrldistance,iTrlstep);
		return(0);	
		// the end	
	}                                                                                   



